Unreliable User mention feature with PostgreSQL
2019-11-01 02:00 - Kenta Kogumasaka

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Issues Estimated time: 0.00 hour

Target version:

Resolution: Duplicate Affected version: 3.4.11

Description

Our Redmine system has been migrated to the new instance with PostgreSQL / Ubuntu 18, but we now observe that the User
mention feature is unreliable.

The symptom is that accounts consisted of lowercase characters only can be found and mentioned, but ones with uppercase
characters only / the combination of uppercase and lowercase cannot be mentioned. Both cases were fine with MySQL before
migration.

Environment:
Redmine version 3.4.11.stable
Ruby version 2.4.6-p354 (2019-04-01) [x86_64-1linux]
Rails version 4.2.11.1
Environment production
Database adapter PostgreSQL

Thank you for your help!

Related issues:
Is duplicate of Redmine - Defect #26892: Link to user in wiki syntax only wor... Closed

History

#1 - 2019-11-01 06:15 - Go MAEDA

The current version of Redmine does not have a mentioning feature. Are you talking about a plugin that provides the feature?

#2 - 2019-11-01 08:22 - Kenta Kogumasaka

Hello Maeda San!

| don't think we've installed any plugin such as https://www.redmine.org/plugins/redmine-mentions. | found #4179#note-41 and #139194#note-37 that
you have already been in a loop, and both patches look already implemented for master.
(See https://github.com/redmine/redmine/blob/master/app/helpers/application_helper.rb#l1134)

That's why | thought the feature has been already in production. What do you think?

#3 - 2019-11-06 04:58 - Go MAEDA
Kenta Kogumasaka wrote:
| don't think we've installed any plugin such as https://www.redmine.org/plugins/redmine-mentions. | found #4179#note-41 and #13919#note-37

that you have already been in a loop, and both patches look already implemented for master.
(See https://github.com/redmine/redmine/blob/master/app/helpers/application_helper.rb#l1134)

Thank you for the detailed information. | understood. My understanding is that "mention" means the link to user feature (#4179) and you cannot make
a link to a user if you use uppercase characters. Is it correct?

#4 - 2019-11-06 09:09 - Kenta Kogumasaka

Yes, it's more or less correct. Strictly speaking, we cannot make a link to a user account that has uppercase character(s). Here is some examples:

Full name Redmine Account Try Result
(case-sensitive)
Yamada, Taro tyamada oo oo Linked
(all are lowercases) 00 oo NG
000o
Yamada, Hanako HYamada @HYamada NG
(H and Y are uppercases) @hyamada
@HYAMADA
John Smith JSMITH @jsmith NG
(all are uppercases) @JSMITH
@JSMith

The accounts that consist of lowercases only can be linked if using @<username> with lowercases.
Thousands of accounts in our Redmine have been imported with LDAP Sync, and | don't feel it would be practical to replace all uppercases to
lowercases in the "users" table.

#5 - 2019-11-06 15:04 - Holger Just

Instead of User.visible.where(:login => name, :type => 'User').first, we should probably use User.visible.find_by_login(name) to find the user in
ApplictionHelper#parse_redmine_links. Here, we already perform a fallback to a case-insensitive match if necessary.

Let me check if that does it...

#6 - 2019-11-09 17:08 - Kenta Kogumasaka

Danke schon, Holger!

#7 - 2019-11-09 17:40 - Mischa The Evil

- Related to Defect #26892: Link to user in wiki syntax only works when login is written in lower case added

#8 - 2019-11-10 23:29 - Marius BALTEANU

- Status changed from New to Needs feedback

test test Kogumasaka, this problem was fixed in Redmine 4.0, please see #26892 for more details.

Not being a very big change, maybe you can apply the fix on your instance.

#9 - 2020-04-14 05:26 - Marius BALTEANU

- Related to deleted (Defect #26892: Link to user in wiki syntax only works when login is written in lower case)

#10 - 2020-04-14 05:26 - Marius BALTEANU

- Is duplicate of Defect #26892: Link to user in wiki syntax only works when login is written in lower case added

#11 - 2020-04-14 05:27 - Marius BALTEANU
- Status changed from Needs feedback to Closed

- Resolution set to Duplicate
